# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetCliDeviceTemplateResult',
    'AwaitableGetCliDeviceTemplateResult',
    'get_cli_device_template',
    'get_cli_device_template_output',
]

@pulumi.output_type
class GetCliDeviceTemplateResult:
    """
    A collection of values returned by getCliDeviceTemplate.
    """
    def __init__(__self__, cli_configuration=None, cli_type=None, description=None, device_type=None, id=None, name=None, version=None):
        if cli_configuration and not isinstance(cli_configuration, str):
            raise TypeError("Expected argument 'cli_configuration' to be a str")
        pulumi.set(__self__, "cli_configuration", cli_configuration)
        if cli_type and not isinstance(cli_type, str):
            raise TypeError("Expected argument 'cli_type' to be a str")
        pulumi.set(__self__, "cli_type", cli_type)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if device_type and not isinstance(device_type, str):
            raise TypeError("Expected argument 'device_type' to be a str")
        pulumi.set(__self__, "device_type", device_type)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="cliConfiguration")
    def cli_configuration(self) -> str:
        """
        CLI configuration
        """
        return pulumi.get(self, "cli_configuration")

    @property
    @pulumi.getter(name="cliType")
    def cli_type(self) -> str:
        """
        CLI type
        """
        return pulumi.get(self, "cli_type")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the device template
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="deviceType")
    def device_type(self) -> str:
        """
        The device type (e.g., `vedge-ISR-4331`)
        """
        return pulumi.get(self, "device_type")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The id of the object
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the device template
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The version of the object
        """
        return pulumi.get(self, "version")


class AwaitableGetCliDeviceTemplateResult(GetCliDeviceTemplateResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCliDeviceTemplateResult(
            cli_configuration=self.cli_configuration,
            cli_type=self.cli_type,
            description=self.description,
            device_type=self.device_type,
            id=self.id,
            name=self.name,
            version=self.version)


def get_cli_device_template(id: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCliDeviceTemplateResult:
    """
    This data source can read the CLI Device Template .

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_cli_device_template(id="f6b2c44c-693c-4763-b010-895aa3d236bd")
    ```


    :param str id: The id of the object
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getCliDeviceTemplate:getCliDeviceTemplate', __args__, opts=opts, typ=GetCliDeviceTemplateResult).value

    return AwaitableGetCliDeviceTemplateResult(
        cli_configuration=pulumi.get(__ret__, 'cli_configuration'),
        cli_type=pulumi.get(__ret__, 'cli_type'),
        description=pulumi.get(__ret__, 'description'),
        device_type=pulumi.get(__ret__, 'device_type'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        version=pulumi.get(__ret__, 'version'))


@_utilities.lift_output_func(get_cli_device_template)
def get_cli_device_template_output(id: Optional[pulumi.Input[str]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCliDeviceTemplateResult]:
    """
    This data source can read the CLI Device Template .

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_cli_device_template(id="f6b2c44c-693c-4763-b010-895aa3d236bd")
    ```


    :param str id: The id of the object
    """
    ...
